C  *****************************************************************
C
C     SUBROUTINE CALMTS: CONSTRUCTION OF SM,HM,HDX,HDY,HDZ
C                  BY wang METHOD
C
C ******************************************************************
      SUBROUTINE CALMTS(NA,NN,DX,DY,DZ,HM,HDX,HDY,HDZ
     &                 ,para,s,dsx,dsy,dsz,rab,drabx,draby,drabz,IP,MAN
     &                 ,HMM,HMX,HMY,HMZ)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      DIMENSION DX(MAN,NA),DY(MAN,NA),DZ(MAN,NA),NN(NA),IP(MAN,NA)
     &         ,HM(4,4,MAN,NA),HMM(4,4),HMX(4,4),HMY(4,4),HMZ(4,4)
     &         ,HDX(4,4,MAN,NA),HDY(4,4,MAN,NA),HDZ(4,4,MAN,NA)
     &         ,para(7,8)
     &         ,s(7,man,na),dsx(7,man,na),dsy(7,man,na),dsz(7,man,na)
     &         ,rab(6,man,na),drabx(6,man,na)
     &         ,draby(6,man,na),drabz(6,man,na)


      DO 100 I=1,NA
            htemp=0.0d0
         MM=NN(I)
c         print *,mm
         DO 110 J=1,MM
            IK=IP(J,I)
            DO 80 L=1,4
               DO 90 K=1,4
                  HMX(L,K)=0.0D0
                  HMY(L,K)=0.0D0
                  HMZ(L,K)=0.0D0
 90            CONTINUE
 80         CONTINUE
            RX=DX(J,I)
            RY=DY(J,I)
            RZ=DZ(J,I)
            R2=RX**2+RY**2+RZ**2
            RR=DSQRT(R2)
            RLL=RX/RR
            RMM=RY/RR
            RNN=RZ/RR

C
C     TWO-CENTER PARAMETERS
C
      HVSS=para(1,1)*rab(1,j,i)**(-para(1,2))
     &    *exp(-para(1,3)*rab(1,j,i)**(para(1,4)))*(1.0d0-s(1,j,i))
      HVSP=para(2,1)*rab(2,j,i)**(-para(2,2))
     &    *exp(-para(2,3)*rab(2,j,i)**(para(2,4)))*(1.0d0-s(2,j,i))
      HVPPS=para(3,1)*rab(3,j,i)**(-para(3,2))
     &    *exp(-para(3,3)*rab(3,j,i)**(para(3,4)))*(1.0d0-s(3,j,i))
      HVPPP=para(4,1)*rab(4,j,i)**(-para(4,2))
     &    *exp(-para(4,3)*rab(4,j,i)**(para(4,4)))*(1.0d0-s(4,j,i))

C     DERIVATIVES OF TWO-CENTER PARAMETERS
      dhvssx=(-para(1,2)*drabx(1,j,i)/rab(1,j,i)
     &        -para(1,3)*para(1,4)
     &                  *rab(1,j,i)**(para(1,4)-1.0d0)*drabx(1,j,i)
     &        -dsx(1,j,i)/(1.0d0-s(1,j,i)))*HVSS
      dhvssy=(-para(1,2)*draby(1,j,i)/rab(1,j,i)
     &        -para(1,3)*para(1,4)
     &                  *rab(1,j,i)**(para(1,4)-1.0d0)*draby(1,j,i)
     &        -dsy(1,j,i)/(1.0d0-s(1,j,i)))*HVSS
      dhvssz=(-para(1,2)*drabz(1,j,i)/rab(1,j,i)
     &        -para(1,3)*para(1,4)
     &                  *rab(1,j,i)**(para(1,4)-1.0d0)*drabz(1,j,i)
     &        -dsz(1,j,i)/(1.0d0-s(1,j,i)))*HVSS

      dhvspx=(-para(2,2)*drabx(2,j,i)/rab(2,j,i)
     &        -para(2,3)*para(2,4)
     &                  *rab(2,j,i)**(para(2,4)-1.0d0)*drabx(2,j,i)
     &        -dsx(2,j,i)/(1.0d0-s(2,j,i)))*HVSP
      dhvspy=(-para(2,2)*draby(2,j,i)/rab(2,j,i)
     &        -para(2,3)*para(2,4)
     &                  *rab(2,j,i)**(para(2,4)-1.0d0)*draby(2,j,i)
     &        -dsy(2,j,i)/(1.0d0-s(2,j,i)))*HVSP
      dhvspz=(-para(2,2)*drabz(2,j,i)/rab(2,j,i)
     &        -para(2,3)*para(2,4)
     &                  *rab(2,j,i)**(para(2,4)-1.0d0)*drabz(2,j,i)
     &        -dsz(2,j,i)/(1.0d0-s(2,j,i)))*HVSP

      dhvppsx=(-para(3,2)*drabx(3,j,i)/rab(3,j,i)
     &        -para(3,3)*para(3,4)
     &                  *rab(3,j,i)**(para(3,4)-1.0d0)*drabx(3,j,i)
     &        -dsx(3,j,i)/(1.0d0-s(3,j,i)))*HVPPS
      dhvppsy=(-para(3,2)*draby(3,j,i)/rab(3,j,i)
     &        -para(3,3)*para(3,4)
     &                  *rab(3,j,i)**(para(3,4)-1.0d0)*draby(3,j,i)
     &        -dsy(3,j,i)/(1.0d0-s(3,j,i)))*HVPPS
      dhvppsz=(-para(3,2)*drabz(3,j,i)/rab(3,j,i)
     &        -para(3,3)*para(3,4)
     &                  *rab(3,j,i)**(para(3,4)-1.0d0)*drabz(3,j,i)
     &        -dsz(3,j,i)/(1.0d0-s(3,j,i)))*HVPPS

      dhvpppx=(-para(4,2)*drabx(4,j,i)/rab(4,j,i)
     &        -para(4,3)*para(4,4)
     &                  *rab(4,j,i)**(para(4,4)-1.0d0)*drabx(4,j,i)
     &        -dsx(4,j,i)/(1.0d0-s(4,j,i)))*HVPPP
      dhvpppy=(-para(4,2)*draby(4,j,i)/rab(4,j,i)
     &        -para(4,3)*para(4,4)
     &                  *rab(4,j,i)**(para(4,4)-1.0d0)*draby(4,j,i)
     &        -dsy(4,j,i)/(1.0d0-s(4,j,i)))*HVPPP
      dhvpppz=(-para(4,2)*drabz(4,j,i)/rab(4,j,i)
     &        -para(4,3)*para(4,4)
     &                  *rab(4,j,i)**(para(4,4)-1.0d0)*drabz(4,j,i)
     &        -dsz(4,j,i)/(1.0d0-s(4,j,i)))*HVPPP


C     HMM
      HMM(1,1)=HVSS
      HMM(1,2)=RLL*HVSP
      HMM(1,3)=RMM*HVSP
      HMM(1,4)=RNN*HVSP
      HMM(2,1)=-RLL*HVSP
      HMM(3,1)=-RMM*HVSP
      HMM(4,1)=-RNN*HVSP
      HMM(2,2)=RLL**2*HVPPS+(1.0D0-RLL**2)*HVPPP
      HMM(3,3)=RMM**2*HVPPS+(1.0D0-RMM**2)*HVPPP
      HMM(4,4)=RNN**2*HVPPS+(1.0D0-RNN**2)*HVPPP
      HMM(2,3)=RLL*RMM*(HVPPS-HVPPP)
      HMM(3,2)=HMM(2,3)
      HMM(3,4)=RMM*RNN*(HVPPS-HVPPP)
      HMM(4,3)=HMM(3,4)
      HMM(2,4)=RLL*RNN*(HVPPS-HVPPP)
      HMM(4,2)=HMM(2,4)
      IF(IK.EQ.I) GO TO 140
C      HMX,HMY,HMZ
      HMX(1,1)=dhvssx
      HMY(1,1)=dhvssy
      HMZ(1,1)=dhvssz

      HMX(1,2)=-HVSP/rr+(rll**2.0d0)/rr*HVSP+rll*dhvspx
      HMY(1,2)=rll*rmm/rr*HVSP+rll*dhvspy
      HMZ(1,2)=rll*rnn/rr*HVSP+rll*dhvspz

      HMX(1,3)=rmm*rll/rr*HVSP+rmm*dhvspx
      HMY(1,3)=-HVSP/rr+(rmm**2.0d0)/rr*HVSP+rmm*dhvspy
      HMZ(1,3)=rmm*rnn/rr*HVSP+rmm*dhvspz

      HMX(1,4)=rnn*rll/rr*HVSP+rnn*dhvspx
      HMY(1,4)=rnn*rmm/rr*HVSP+rnn*dhvspy
      HMZ(1,4)=-HVSP/rr+(rnn**2.0d0)/rr*HVSP+rnn*dhvspz

      HMX(2,1)=-HMX(1,2)
      HMY(2,1)=-HMY(1,2)
      HMZ(2,1)=-HMZ(1,2)
      HMX(3,1)=-HMX(1,3)
      HMY(3,1)=-HMY(1,3)
      HMZ(3,1)=-HMZ(1,3)
      HMX(4,1)=-HMX(1,4)
      HMY(4,1)=-HMY(1,4)
      HMZ(4,1)=-HMZ(1,4)

      v1=HVPPS-HVPPP
      v2x=dhvppsx-dhvpppx
      v2y=dhvppsy-dhvpppy
      v2z=dhvppsz-dhvpppz

      HMX(2,2)=-2.0d0*rll/rr*v1
     &            +2.0d0*(rll**3)/rr*v1+(rll**2)*v2x+dhvpppx
      HMY(2,2)=2.0d0*(rll**2)*rmm/rr*v1+(rll**2)*v2y+dhvpppy
      HMZ(2,2)=2.0d0*(rll**2)*rnn/rr*v1+(rll**2)*v2z+dhvpppz

      HMX(3,3)=2.0d0*(rmm**2)*rll/rr*v1+(rmm**2)*v2x+dhvpppx
      HMY(3,3)=-2.0d0*rmm/rr*v1
     &            +2.0d0*(rmm**3)/rr*v1+(rmm**2)*v2y+dhvpppy
      HMZ(3,3)=2.0d0*(rmm**2)*rnn/rr*v1+(rmm**2)*v2z+dhvpppz

      HMX(4,4)=2.0d0*(rnn**2)*rll/rr*v1+(rnn**2)*v2x+dhvpppx
      HMY(4,4)=2.0d0*(rnn**2)*rmm/rr*v1+(rnn**2)*v2y+dhvpppy
      HMZ(4,4)=-2.0d0*rnn/rr*v1
     &            +2.0d0*(rnn**3)/rr*v1+(rnn**2)*v2z+dhvpppz

      HMX(2,3)=-rmm/rr*v1+2.0d0*(rll**2)*rmm/rr*v1+rll*rmm*v2x
      HMY(2,3)=-rll/rr*v1+2.0d0*rll*(rmm**2)/rr*v1+rll*rmm*v2y
      HMZ(2,3)=2.0d0*rll*rmm*rnn/rr*v1+rll*rmm*v2z
      HMX(3,2)=HMX(2,3)
      HMY(3,2)=HMY(2,3)
      HMZ(3,2)=HMZ(2,3)

      HMX(3,4)=2.0d0*rll*rmm*rnn/rr*v1+rmm*rnn*v2x
      HMY(3,4)=-rnn/rr*v1+2.0d0*(rmm**2)*rnn/rr*v1+rmm*rnn*v2y
      HMZ(3,4)=-rmm/rr*v1+2.0d0*rmm*(rnn**2)/rr*v1+rmm*rnn*v2z
      HMX(4,3)=HMX(3,4)
      HMY(4,3)=HMY(3,4)
      HMZ(4,3)=HMZ(3,4)

      HMX(2,4)=-rnn/rr*v1+2.0d0*(rll**2)*rnn/rr*v1+rll*rnn*v2x
      HMY(2,4)=2.0d0*rll*rmm*rnn/rr*v1+rll*rnn*v2y
      HMZ(2,4)=-rll/rr*v1+2.0d0*rll*(rnn**2)/rr*v1+rll*rnn*v2z
      HMX(4,2)=HMX(2,4)
      HMY(4,2)=HMY(2,4)
      HMZ(4,2)=HMZ(2,4)
C
  140 DO 150 L=1,4
      DO 160 K=1,4
      HM(K,L,J,I)=HMM(L,K)
      HDX(K,L,J,I)=HMX(L,K)
      HDY(K,L,J,I)=HMY(L,K)
      HDZ(K,L,J,I)=HMZ(L,K)

C         if (i.eq.1)then
Cc         if ((j.eq.4).or.(j.eq.5))then
CC         open(52,file='dh_test.dat')
C
C
Cc         open(52,file='dh.dat')
C
C          open(51,file='check1.dat')
C
C
Cc         if ((dabs(HDX(K,L,J,I)).ge.0.001d0)
Cc     &     .or.(dabs(HDY(K,L,J,I)).ge.0.001d0)) then
CC         WRITE(52,*) i,j,l,k,s(1,j,i),rab(1,j,i)
CC         WRITE(52,*) i,j,l,k,HVSS,HVSP,HVPPS,HVPPP
CC         WRITE(52,*) i,j,l,k,rr,RLL,RMM,RNN
C         WRITE(51,*) i,j,l,k,HDX(K,L,J,I),HDY(K,L,J,I)
Cc         WRITE(52,*) i,j,ik,l,k,-HVSP/rr,HMX(L,K)
Cc          endif
Cc          endif
C          endif
  160 CONTINUE
  150 CONTINUE
  110 CONTINUE
  100 CONTINUE

      RETURN
      END
