C  *****************************************************************
C
C     SUBROUTINE CALMTS: CONSTRUCTION OF SM,HM,HDX,HDY,HDZ
C                  BY wang METHOD
C
C ******************************************************************
      SUBROUTINE CALMTS_old(NA,NN,DX,DY,DZ,HM,HDX,HDY,HDZ,IP,MAN)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      DIMENSION DX(MAN,NA),DY(MAN,NA),DZ(MAN,NA),NN(NA),IP(MAN,NA)
     &         ,HM(4,4,MAN,NA),HMM(4,4),HMX(4,4),HMY(4,4),HMZ(4,4)
     &         ,HDX(4,4,MAN,NA),HDY(4,4,MAN,NA),HDZ(4,4,MAN,NA)

c     V(ll'm)դΥѥ᡼
c
      tss=-5.00d0
      tsp=4.70d0
      tpps=5.50d0
      tppp=-1.55d0

      rn=2.0d0
      rnc=6.5d0
      rc=2.18d0
      roo=1.536329d0
      rr1=2.45d0

      rocnc=(roo/rc)**rnc

      rp0=8.18555d0
      rm=3.30304d0
      rmc=8.6655d0
      dc=2.1052d0
      d0=1.64d0
      d1=2.57d0

      docmc=(d0/dc)**rmc
c
      rmax=2.60d0
      RS=rmax

c     coefficients for polynomials
c
      sc0=6.7392620074314d0*10.0d0**(-3)
      sc1=-8.1885359517898d0*10.0d0**(-2)
      sc2=0.1932365259144d0
      sc3=0.3542874332380d0
c
      pc0=2.2504290109d0*10.0d0**(-8)
      pc1=-1.4408640561d0*10.0d0**(-6)
      pc2=2.1043303374d0*10.0d0**(-5)
      pc3=6.6024390226d0*10.0d0**(-5)

      fc0=-2.5909765118191d0
      fc1=0.5721151498619d0
      fc2=-1.7896349903996d0*10.0d0**(-3)
      fc3=2.3539221516757d0*10.0d0**(-5)
      fc4=-1.24251169551587d0*10.0d0**(-7)

      DO 100 I=1,NA
         MM=NN(I)
c         print *,mm
         DO 110 J=1,MM
            IK=IP(J,I)
            DO 80 L=1,4
               DO 90 K=1,4
                  HMX(L,K)=0.0D0
                  HMY(L,K)=0.0D0
                  HMZ(L,K)=0.0D0
 90            CONTINUE
 80         CONTINUE
            RX=DX(J,I)
            RY=DY(J,I)
            RZ=DZ(J,I)
            R2=RX**2+RY**2+RZ**2
            RR=DSQRT(R2)
            RLL=RX/RR
            RMM=RY/RR
            RNN=RZ/RR

C
C     TWO-CENTER PARAMETERS
C

      IF(RR.GT.RR1) then
      XX=RR-RR1
      DGF=SC0+SC1*XX+SC2*XX*XX+SC3*XX*XX*XX
      else
      EXR=DEXP(RN*(ROCNC-(RR/RC)**RNC))
      DGF=((ROO/RR)**RN)*EXR
      endif

      VSS=TSS*DGF
      VSP=TSP*DGF
      VPPS=TPPS*DGF
      VPPP=TPPP*DGF

C     DERIVATIVES OF TWO-CENTER PARAMETERS

      DGR=(-RN/RR-RN*RNC/RR*((RR/RC)**RNC))*DGF

      IF(RR.GT.RR1) DGR=SC1+2.0D0*SC2*XX+3.0D0*SC3*XX*XX

      DSS=TSS*DGR
      DSP=TSP*DGR
      DPPS=TPPS*DGR
      DPPP=TPPP*DGR

C     HMM
      HMM(1,1)=VSS                                                      00102400
      HMM(1,2)=RLL*VSP                                                  00102500
      HMM(1,3)=RMM*VSP                                                  00102600
      HMM(1,4)=RNN*VSP                                                  00102700
      HMM(2,1)=-RLL*VSP                                                 00102800
      HMM(3,1)=-RMM*VSP                                                 00102900
      HMM(4,1)=-RNN*VSP                                                 00103000
      HMM(2,2)=RLL**2*VPPS+(1.0D0-RLL**2)*VPPP                          00103100
      HMM(3,3)=RMM**2*VPPS+(1.0D0-RMM**2)*VPPP                          00103200
      HMM(4,4)=RNN**2*VPPS+(1.0D0-RNN**2)*VPPP                          00103300
      HMM(2,3)=RLL*RMM*(VPPS-VPPP)                                      00103400
      HMM(3,2)=HMM(2,3)                                                 00103500
      HMM(3,4)=RMM*RNN*(VPPS-VPPP)                                      00103600
      HMM(4,3)=HMM(3,4)                                                 00103700
      HMM(2,4)=RLL*RNN*(VPPS-VPPP)                                      00103800
      HMM(4,2)=HMM(2,4)
      IF(IK.EQ.I) GO TO 140
C      HMX,HMY,HMZ
      HMX(1,1)=-RLL*DSS                                                 00104200
      HMY(1,1)=-RMM*DSS                                                 00104300
      HMZ(1,1)=-RNN*DSS                                                 00104400
      V1=-VSP/RR+DSP                                                    00104500
      HMX(1,2)=-VSP/RR-RLL**2*V1                                        00104600
      HMY(1,2)=-RLL*RMM*V1                                              00104700
      HMZ(1,2)=-RLL*RNN*V1                                              00104800
      HMX(1,3)=-RLL*RMM*V1                                              00104900
      HMY(1,3)=-VSP/RR-RMM**2*V1                                        00105000
      HMZ(1,3)=-RMM*RNN*V1                                              00105100
      HMX(1,4)=-RLL*RNN*V1                                              00105200
      HMY(1,4)=-RMM*RNN*V1                                              00105300
      HMZ(1,4)=-VSP/RR-RNN**2*V1                                        00105400
      HMX(2,1)=-HMX(1,2)                                                00105500
      HMY(2,1)=-HMY(1,2)                                                00105600
      HMZ(2,1)=-HMZ(1,2)                                                00105700
      HMX(3,1)=-HMX(1,3)                                                00105800
      HMY(3,1)=-HMY(1,3)                                                00105900
      HMZ(3,1)=-HMZ(1,3)                                                00106000
      HMX(4,1)=-HMX(1,4)                                                00106100
      HMY(4,1)=-HMY(1,4)                                                00106200
      HMZ(4,1)=-HMZ(1,4)                                                00106300
      V2=VPPS-VPPP                                                      00106400
      HMX(2,2)=-2.0D0*RLL*(1.0D0-RLL**2)/RR*V2-RLL**3*DPPS              00106500
     &-RLL*(1.0D0-RLL**2)*DPPP                                          00106600
      HMY(2,2)=2.0D0*RLL**2*RMM/RR*V2-RLL**2*RMM*DPPS                   00106700
     &-RMM*(1.0D0-RLL**2)*DPPP                                          00106800
      HMZ(2,2)=2.0D0*RLL**2*RNN/RR*V2-RLL**2*RNN*DPPS                   00106900
     &-RNN*(1.0D0-RLL**2)*DPPP                                          00107000
      HMX(3,3)=2.0D0*RLL*RMM**2/RR*V2-RLL*RMM**2*DPPS                   00107100
     &-RLL*(1.0D0-RMM**2)*DPPP                                          00107200
      HMY(3,3)=-2.0D0*RMM*(1.0D0-RMM**2)/RR*V2-RMM**3*DPPS              00107300
     &-RMM*(1.0D0-RMM**2)*DPPP                                          00107400
      HMZ(3,3)=2.0D0*RMM**2*RNN/RR*V2-RNN*RMM**2*DPPS                   00107500
     &-RNN*(1.0D0-RMM**2)*DPPP                                          00107600
      HMX(4,4)=2.0D0*RLL*RNN**2/RR*V2-RLL*RNN**2*DPPS                   00107700
     &-RLL*(1.0D0-RNN**2)*DPPP                                          00107800
      HMY(4,4)=2.0D0*RMM*RNN**2/RR*V2-RMM*RNN**2*DPPS                   00107900
     &-RMM*(1.0D0-RNN**2)*DPPP                                          00108000
      HMZ(4,4)=-2.0D0*RNN*(1.0D0-RNN**2)/RR*V2-RNN**3*DPPS              00108100
     &-RNN*(1.0D0-RNN**2)*DPPP                                          00108200
      V3=DPPS-DPPP                                                      00108300
      HMX(2,3)=-RMM*(1.0D0-2.0D0*RLL**2)/RR*V2-RLL**2*RMM*V3            00108400
      HMY(2,3)=-RLL*(1.0D0-2.0D0*RMM**2)/RR*V2-RLL*RMM**2*V3            00108500
      HMZ(2,3)=2.0D0*RLL*RMM*RNN/RR*V2-RLL*RMM*RNN*V3                   00108600
      HMX(3,2)=HMX(2,3)                                                 00108700
      HMY(3,2)=HMY(2,3)                                                 00108800
      HMZ(3,2)=HMZ(2,3)                                                 00108900
      HMX(3,4)=2.0D0*RLL*RMM*RNN/RR*V2-RLL*RMM*RNN*V3                   00109000
      HMY(3,4)=-RNN*(1.0D0-2.0D0*RMM**2)/RR*V2-RMM**2*RNN*V3            00109100
      HMZ(3,4)=-RMM*(1.0D0-2.0D0*RNN**2)/RR*V2-RMM*RNN**2*V3            00109200
      HMX(4,3)=HMX(3,4)                                                 00109300
      HMY(4,3)=HMY(3,4)                                                 00109400
      HMZ(4,3)=HMZ(3,4)                                                 00109500
      HMX(2,4)=-RNN*(1.0D0-2.0D0*RLL**2)/RR*V2-RNN*RLL**2*V3            00109600
      HMY(2,4)=2.0D0*RLL*RMM*RNN/RR*V2-RLL*RMM*RNN*V3                   00109700
      HMZ(2,4)=-RLL*(1.0D0-2.0D0*RNN**2)/RR*V2-RLL*RNN**2*V3            00109800
      HMX(4,2)=HMX(2,4)                                                 00109900
      HMY(4,2)=HMY(2,4)                                                 00110000
      HMZ(4,2)=HMZ(2,4)
C
  140 DO 150 L=1,4
      DO 160 K=1,4
      HM(K,L,J,I)=HMM(L,K)
      HDX(K,L,J,I)=HMX(L,K)
      HDY(K,L,J,I)=HMY(L,K)
      HDZ(K,L,J,I)=HMZ(L,K)

C         if (i.eq.1)then
Cc         if ((j.eq.4).or.(j.eq.5))then
CC         open(52,file='dh_test.dat')
C
C
Cc         open(52,file='dh.dat')
C
C          open(51,file='check1.dat')
C
C
Cc         if ((dabs(HDX(K,L,J,I)).ge.0.001d0)
Cc     &     .or.(dabs(HDY(K,L,J,I)).ge.0.001d0)) then
CC         WRITE(52,*) i,j,l,k,s(1,j,i),rab(1,j,i)
CC         WRITE(52,*) i,j,l,k,HVSS,HVSP,HVPPS,HVPPP
CC         WRITE(52,*) i,j,l,k,rr,RLL,RMM,RNN
C         WRITE(51,*) i,j,l,k,HDX(K,L,J,I),HDY(K,L,J,I)
Cc         WRITE(52,*) i,j,ik,l,k,-HVSP/rr,HMX(L,K)
Cc          endif
Cc          endif
C          endif
  160 CONTINUE
  150 CONTINUE
  110 CONTINUE
  100 CONTINUE

      RETURN
      END
