C  ******************************************************************
C
C      SUBROUTINE DIAG: CALCULATION OF DIAGONAL ELEMENTS
C
C  ******************************************************************
      SUBROUTINE DIAG(NA,EI,ES,EP,para,s,dsx,dsy,dsz
     &               ,rab,drabx,draby,drabz
     &               ,dex,dey,dez,NN,man)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      DIMENSION EI(4,NA),NN(NA)
     &         ,para(7,8)
     &         ,s(7,man,na),dsx(7,man,na),dsy(7,man,na),dsz(7,man,na)
     &         ,rab(6,man,na),drabx(6,man,na)
     &         ,draby(6,man,na),drabz(6,man,na)
     &         ,dex(na),dey(na),dez(na)

      do i=1,na
      dex(i)=0.0d0
      dey(i)=0.0d0
      dez(i)=0.0d0
      enddo

      DO 100 I=1,NA
         MM=NN(I)
         el=0.0d0
         DO 110 J=1,MM
            etemp=para(6,1)*rab(6,j,i)**(-para(6,2))
     &    *exp(-para(6,3)*rab(6,j,i)**(para(6,4)))*(1.0d0-s(6,j,i))
            el=el+etemp

            dex(i)=dex(i)+(-para(6,2)*drabx(6,j,i)/rab(6,j,i)
     &             -para(6,3)*para(6,4)
     &              *rab(6,j,i)**(para(6,4)-1.0d0)*drabx(6,j,i)
     &             -dsx(6,j,i)/(1.0d0-s(6,j,i)))*etemp
            dey(i)=dey(i)+(-para(6,2)*draby(6,j,i)/rab(6,j,i)
     &             -para(6,3)*para(6,4)
     &              *rab(6,j,i)**(para(6,4)-1.0d0)*draby(6,j,i)
     &             -dsy(6,j,i)/(1.0d0-s(6,j,i)))*etemp
            dez(i)=dez(i)+(-para(6,2)*drabz(6,j,i)/rab(6,j,i)
     &             -para(6,3)*para(6,4)
     &              *rab(6,j,i)**(para(6,4)-1.0d0)*drabz(6,j,i)
     &             -dsz(6,j,i)/(1.0d0-s(6,j,i)))*etemp

 110     continue
      EI(1,I)=es+el
      EI(2,I)=ep+el
      EI(3,I)=ep+el
      EI(4,I)=ep+el
  100 CONTINUE
      RETURN
      END
