subroutine diamond(na,x,y,z,a1,a2,a3)
  
  IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
  dimension x(na),y(na),z(na),a1(3),a2(3),a3(3)

  ao=3.57d0
  iix=1
  iiy=1
  iiz=1

      x(1)=0.0d0
      y(1)=0.0d0
      z(1)=0.0d0
      x(2)=0.0d0
      y(2)=ao/2.0d0
      z(2)=ao/2.0d0
      x(3)=ao/2.0d0
      y(3)=0.0d0
      z(3)=ao/2.0d0
      x(4)=ao/2.0d0
      y(4)=ao/2.0d0
      z(4)=0.0d0
      do i=5,8
         x(i)=x(i-4)+ao/4.0d0
         y(i)=y(i-4)+ao/4.0d0
         z(i)=z(i-4)+ao/4.0d0
      enddo
      ncell=8

      if (na/=8*iix*iiy*iiz) stop 'Error in diamond.f90'

      ! Multiply in x y z directions
      iii=ncell
      jjj=iii
      if (iix.ge.2) then
         do k=2,iix
            do j=1,jjj
               iii=iii+1
               x(iii)=x(iii-jjj)+ao
               y(iii)=y(iii-jjj)
               z(iii)=z(iii-jjj)
            enddo
         enddo
         jjj=iii
      endif
      if (iiy.ge.2) then
         do k=2,iiy
            do j=1,jjj
               iii=iii+1
               x(iii)=x(iii-jjj)
               y(iii)=y(iii-jjj)+ao
               z(iii)=z(iii-jjj)
            enddo
         enddo
         jjj=iii
      endif
      if (iiz.ge.2) then
         do k=2,iiz
            do j=1,jjj
               iii=iii+1
               x(iii)=x(iii-jjj)
               y(iii)=y(iii-jjj)
               z(iii)=z(iii-jjj)+ao
            enddo
         enddo
      endif
!      x(1)=x(1)+ao/10.0d0
!      y(1)=y(1)+ao/10.0d0
!      z(1)=z(1)+ao/10.0d0

!      rx=rx+ao/5.0d0
!      ry=ry+ao/5.0d0
!      rz=rz+ao/5.0d0

      a1=0.0d0
      a2=0.0d0
      a3=0.0d0
      a1(1)=ao*dble(iix)
      a2(2)=ao*dble(iiy)
      a3(3)=ao*dble(iiz)

      ! Convert to Bohr
       do i=1,na
         x(i)=x(i)/0.529177d0
         y(i)=y(i)/0.529177d0
         z(i)=z(i)/0.529177d0
      enddo
      do i=1,3
         a1(i)=a1(i)/0.529177d0
         a2(i)=a2(i)/0.529177d0
         a3(i)=a3(i)/0.529177d0
      enddo
 
end subroutine diamond
