C  *****************************************************************    
C                                                                       
C      SUBROUTINE KSCST_c5    K POINT (30) (C5)               
C                                                                      
C  ****************************************************************    
      SUBROUTINE kscst_c5(NS,XS,YS,ZS,A,a1,a2,a3,ao,pi,gamma)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C) 
      DIMENSION XS(NS),YS(NS),ZS(NS),A(NS),a1(3),a2(3),a3(3)                              
      
c     ճʻҥ٥ȥ 
c      b1x=4.0d0*pi/3.0d0/ao*3.0d0*dsqrt(2.0d0)/2.0d0
c      b1z=-4.0d0*pi/3.0d0/ao*3.0d0*dsqrt(2.0d0)/2.0d0*dtan(gamma)
c      b2y=4.0d0*pi/3.0d0/ao*dsqrt(3.0d0/2.0d0)
c      b3z=4.0d0*pi/3.0d0/ao*dsqrt(3.0d0)/2.0d0

c      print *,b1x,b1z,b2y,b3z

      v=a1(1)*a2(2)*a3(3)
      b1x=pi/a1(1)
      b2y=pi/a2(2)
      b3z=pi/a3(3)
      
c      print *,b1x,b1z,b2y,b3z
      
      mx=4
      my=8
      mz=8
      
      ik=0
      DO 10 IX=1,MX
      DO 20 IY=1,MY
      DO 30 IZ=1,MZ
      IK=IK+1
      XS(IK)=-b1x+2.0d0*b1x*dble(ix)/dble(mx)                                 
      YS(IK)=-b2y+2.0d0*b2y*dble(iy)/dble(my) 
      ZS(IK)=-b3z+2.0d0*b3z*dble(iz)/dble(mz)                      
      A(IK)=1.0D0/NS
   30 CONTINUE
   20 CONTINUE
   10 CONTINUE
      
      
      RETURN                                                           
      END    
