C  ******************************************************************
C
C     SUBROUTINE RELAX:  RELAXATION FOLLOWING ATOMIC FORCES
C           DISPLACEMENT DDX=PR*FX     DD.LT.PDM
C
C  *******************************************************************
      SUBROUTINE RELAX(NA,X,Y,Z,xn,yn,zn,xo,yo,zo,FX,FY,FZ
     &                ,dt,wm,bl,sumt,enkin,t,tt,istep
     &                ,a1,a2,a3,px,py,pz,dtx,dty,dtz,kr)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      DIMENSION X(NA),Y(NA),Z(NA),FX(NA),FY(NA),FZ(NA)
     &         ,XN(NA),YN(NA),ZN(NA),XO(NA),YO(NA),ZO(NA)
     &         ,px(na),py(na),pz(na),dtx(na),dty(na),dtz(na)
     &         ,a1(3),a2(3),a3(3)
c-----줿ϤѤƸҤ򣱥ƥåư
      do i=1,na
      x(i)=x(i)*1.0d-10
      y(i)=y(i)*1.0d-10
      z(i)=z(i)*1.0d-10
      xo(i)=xo(i)*1.0d-10
      yo(i)=yo(i)*1.0d-10
      zo(i)=zo(i)*1.0d-10
      enddo

C      print *,istep,x(1),y(1)
C      print *,istep,xo(1),yo(1)

C      print *,istep,fx(1),fy(1)
C      print *,wm*6.02d23,dt
      do 110 k=1,na
         xn(k)=2.0d0*x(k)-xo(k)+dt**2/wm*fx(k)
         yn(k)=2.0d0*y(k)-yo(k)+dt**2/wm*fy(k)
         zn(k)=2.0d0*z(k)-zo(k)+dt**2/wm*fz(k)
 110  continue
C      print *,istep,xn(1),x(1),xo(1),fx(1)

c      do i =1,na
c      print *,"force",i,dt**2/wm*fx(k),dt**2/wm*fy(k),dt**2/wm*fz(k)
c      print *,xo(i),yo(i),zo(i)
c      print *,x(i),y(i),z(i)
c      print *,xn(i),yn(i),zn(i)
c      enddo

c-----ư̤η׻
      do 120 k=1,na
         px(k)=(xn(k)-x(k))/dt*wm
         py(k)=(yn(k)-y(k))/dt*wm
         pz(k)=(zn(k)-z(k))/dt*wm
C       if(mod(istep,2000).eq.1) write(7,*) istep,k
C     &                                    ,x(k),y(k),z(k)
C     &                                    ,xo(k),yo(k),zo(k)

 120  continue
c-----ưͥ륮η׻
      enkin=0.0d0
      do 105 k=1,na
         enkintemp=(px(k)**2+py(k)**2+pz(k)**2)/wm/2.0d0*6.24146d18
         enkin=enkin+enkintemp
C      if(mod(istep,2000).eq.1)
C     &  write(7,*) enkin,k,enkintemp
C     &   ,(px(k)**2+py(k)**2+pz(k)**2),1.0d0/wm/2.0d0*6.24146d18
 105  continue
c-----ưͥ륮λʿѤȲ٤η׻
      tt=2.0d0*enkin/dble(na)/3.0d0/bl
      sumt=sumt+tt
c      print *, enkin,bl,tt
C      print *," t=",t," tt=",tt
c-----®٥󥰤ˤ벹Ĵ(P.79(4.3))
      if (mod(kr,5).eq.1) then
c      if (tt.lt.1e-20) go to 131
      do 130 k=1,na
         xn(k)=x(k)
         yn(k)=y(k)
         zn(k)=z(k)


cc         dtx(k)=x(k)-xo(k)+dt**2/wm*fx(k)
cc         xn(k)=x(k)+dsqrt(t/tt)*dtx(k)
cc
cc         dty(k)=y(k)-yo(k)+dt**2/wm*fy(k)
cc         yn(k)=y(k)+dsqrt(t/tt)*dty(k)
cc
cc         dtz(k)=z(k)-zo(k)+dt**2/wm*fz(k)
cc         zn(k)=z(k)+dsqrt(t/tt)*dtz(k)
 130  continue
c 131  continue
      endif
C
C      print *,istep,xn(1),yn(1)

      do i=1,na
      x(i)=x(i)*1.0d10
      y(i)=y(i)*1.0d10
      z(i)=z(i)*1.0d10
      xn(i)=xn(i)*1.0d10
      yn(i)=yn(i)*1.0d10
      zn(i)=zn(i)*1.0d10
      enddo








C      do i =1,na
Cc      print *,"force",i,fx(i),fy(i),fz(i)
C      print *,x(i),y(i),z(i)
C      print *,xn(i),yn(i),zn(i)
C      enddo




c      DO 100 I=1,NA
c      DDX=PR*FX(I)
c      DDY=PR*FY(I)
c      DDZ=PR*FZ(I)
c      DD=DSQRT(DDX**2+DDY**2+DDZ**2)
c      IF(DD.LE.PDM) GO TO 10
c      DDX=DDX*PDM/DD
c      DDY=DDY*PDM/DD
c      DDZ=DDZ*PDM/DD
c   10 X(I)=X(I)+DDX
c      Y(I)=Y(I)+DDY
c      Z(I)=Z(I)+DDZ
c  100 CONTINUE
      RETURN
      END
