************************************************************************
      SUBROUTINE SPLC(XX, N, YY, C, NC, IER,la,lb,lm,alpha)
************************************************************************

      IMPLICIT REAL*8(A-H,O-Z)

      double precision XX(0:N),YY(0:N),C(0:N,3)
      double precision la(0:n),lb(0:n),lm(0:n),alpha(0:n)

C
      IF (N.LT.2 .OR. NC.LT.N-1) THEN
         IER = 2
         WRITE(*,*) '(SUBR. SPLC) INVALID ARGUMENT.',N,NC
         RETURN
      ENDIF
      DO 5 I=1,N-1
         IF (xx(I) .GE. xx(I+1)) THEN
            IER = 1
            WRITE(*,*) '(SUBR. SPLC) X SHOULD SATISFY UPWARD ORDER.'
            RETURN
         ENDIF
    5 CONTINUE

      IER = 0
C  ü 252ڡ (13ˤ

      c(0,1)=1.0d0
      c(n,2)=1.0d0
      c(0,3)=0.0d0
      c(n,3)=0.0d0

C  󼰤η

      IF (N .NE. 2) THEN
       H1 = xx(1) - xx(0)
       Y1 = yy(1) - yy(0)
       DO 80 I=1,N-1
        H2 = xx(I+1) - xx(I)
        Y2 = yy(I+1) - yy(I)
        HH = H1 + H2
        C(I,1) = H2 / HH
        C(I,2) = 1.0D0 - C(I,1)
        C(I,3) = 6.0D0 * (Y2 / H2 - Y1 / H1) / HH
        H1 = H2
        Y1 = Y2
 80   continue
      ENDIF

C  η׻

      la(0)=2.0d0
      do 10 i=1,n
         alpha(i)=c(i,2)/la(i-1)
         la(i)=2.0d0-alpha(i)*c(i-1,1)
 10   continue
      lb(0)=c(0,3)
      do 20 i=1,n
         lb(i)=c(i,3)-alpha(i)*lb(i-1)
 20   continue

      lm(n)=lb(n)/la(n)
      do 30 i=2,n+1
         lm(n-i+1)=(lb(n-i+1)-c(n-i+1,2)*lm(n-i+2))/la(n-i+1)
 30   continue

c  η׻

      do 40 i=0,n-1
         hi=xx(i+1)-xx(i)
         c(i,3)=(lm(i+1)-lm(i))/6.0d0*hi
         c(i,2)=lm(i)/2.0d0
         c(i,1)=(yy(i+1)-yy(i))/hi-c(i,2)*hi-c(i,3)*hi**2.0d0
 40   continue

       RETURN
       END
