!subroutine const_hs(na,nm,man,ns,ks,x,y,z,dx,dy,dz,ar,ai,sr,si, &
!     ip,nn,xs,ys,zs,rou,droux2,drouy2,drouz2, &
!     es,ep,desx,desy,desz,depx,depy,depz, &
!     hdx,hdy,hdz,sdx,sdy,sdz)
!     sdx,sdy,sdz)
subroutine const_hs(ks)
  use variables
  implicit double precision(a,b,d-h,o-z),integer(i-n),complex*16(c)
  double precision :: hmm(4,4),smm(4,4), &
       hmx(4,4),hmy(4,4),hmz(4,4),smx(4,4),smy(4,4),smz(4,4)
  nm=mm
!  dimension x(na),y(na),z(na),dx(man,na),dy(man,na),dz(man,na), &
!       ar(nm,nm),ai(nm,nm),sr(nm,nm),si(nm,nm), &
!       ip(man,na),nn(na),hmm(4,4),smm(4,4), &
!       hmx(4,4),hmy(4,4),hmz(4,4),smx(4,4),smy(4,4),smz(4,4), &
!       xs(ns),ys(ns),zs(ns),rou(na),es(na),ep(na), &
!       desx(na,na),desy(na,na),desz(na,na), &
!       depx(na,na),depy(na,na),depz(na,na), &
!       hdx(4,4,man,na),hdy(4,4,man,na),hdz(4,4,man,na), &
!       sdx(4,4,man,na),sdy(4,4,man,na),sdz(4,4,man,na), &
!       droux2(na,na),drouy2(na,na),drouz2(na,na)
!c     &          sss(4,4,man,na),hhh(4,4,man,na)

!c-----Si-parameter-------------------------------------------
!c      call para_si(rum,as,bs,gs,rcs,aq,bp,gp,rcp,ro,rlo, &
!c                  asss,bsss,esss,dsss,asps,bsps,esps,dsps, &
!c                  apps,bpps,epps,dpps,appp,bppp,eppp,dppp, &
!c                  psss,qsss,rsss,ssss,psps,qsps,rsps,ssps, &
!c                  ppps,qpps,rpps,spps,pppp,qppp,rppp,sppp)
!c      go to 9000
!cc-----C-parameter--------------------------------------------
  call para_c(rum,as,bs,gs,rcs,aq,bp,gp,rcp,ro,rlo, &
       asss,bsss,esss,dsss,asps,bsps,esps,dsps, &
       apps,bpps,epps,dpps,appp,bppp,eppp,dppp, &
       psss,qsss,rsss,ssss,psps,qsps,rsps,ssps, &
       ppps,qpps,rpps,spps,pppp,qppp,rppp,sppp)
!cc------------------------------------------------------------      

!9000 continue

  do i=1,nm
     do j=1,nm
        ar(i,j)=0.0d0
        ai(i,j)=0.0d0
        sr(i,j)=0.0d0
        si(i,j)=0.0d0
     enddo
  enddo

  do i=1,na
     do j=1,na
        droux2(i,j)=0.0d0
        drouy2(i,j)=0.0d0
        drouz2(i,j)=0.0d0
     enddo
  enddo

  do i=1,na
     rou(i)=0.0d0
     ni=nn(i)
     do j=1,ni
!c            do k=1,4
!c               do l=1,4
!c                  hmx(k,l)=0.0d0
!c                  hmy(k,l)=0.0d0
!c                  hmz(k,l)=0.0d0
!c                  smx(k,l)=0.0d0
!c                  smy(k,l)=0.0d0
!c                  smz(k,l)=0.0d0
!c               enddo
!c            enddo
        ik=ip(j,i)
        rx=dx(j,i)
        ry=dy(j,i)
        rz=dz(j,i)
!        write(79,*) rx,ry,rz
        r2=rx*rx+ry*ry+rz*rz
        rr=dsqrt(r2)
        rll=rx/rr
        rmm=ry/rr
        rnn=rz/rr
        rk=xs(ks)*rx+ys(ks)*ry+zs(ks)*rz
        cc=dcmplx(0.0d0,rk)
        ce=cdexp(cc)
        fff=1.0D0/(1.0D0+DEXP((RR-Ro)/rlo+5.0d0))
        dff=dexp((RR-Ro)/rlo+5.0d0)/rlo
        VSS=(asss+bsss*rr+esss*r2)*dexp(-dsss*dsss*rr)*fff
        VSP=(asps+bsps*rr+esps*r2)*dexp(-dsps*dsps*rr)*fff
        VPPS=(apps+bpps*rr+epps*r2)*dexp(-dpps*dpps*rr)*fff
        VPPP=(appp+bppp*rr+eppp*r2)*dexp(-dppp*dppp*rr)*fff

        oss=(1.0d0+psss*rr+qsss*r2+rsss*r2*rr) &
             *dexp(-ssss*ssss*rr)*fff
        osp=(psps*rr+qsps*r2+rsps*r2*rr) &
             *dexp(-ssps*ssps*rr)*fff
        opps=(1.0d0+ppps*rr+qpps*r2+rpps*r2*rr) &
             *dexp(-spps*spps*rr)*fff
        oppp=(1.0d0+pppp*rr+qppp*r2+rppp*r2*rr) &
             *dexp(-sppp*sppp*rr)*fff
        
        rou(i)=rou(i)+dexp(-(rum*rum)*rr)*fff
        if(ks.eq.1) then
           write(39,'(4d16.8)'), vss,vsp,vpps,vppp
           write(39,'(4d16.8)'), oss,osp,opps,oppp
        endif
        if(ik.ne.i) then
           droux2(i,i)=droux2(i,i) &
                +(rum*rum+fff*dff)*dexp(-rum*rum*rr)*fff*rll
           drouy2(i,i)=drouy2(i,i) &
                +(rum*rum+fff*dff)*dexp(-rum*rum*rr)*fff*rmm
           drouz2(i,i)=drouz2(i,i) &
                +(rum*rum+fff*dff)*dexp(-rum*rum*rr)*fff*rnn

           droux2(i,ik)=droux2(i,ik) &
                -(rum*rum+fff*dff)*dexp(-rum*rum*rr)*fff*rll
           drouy2(i,ik)=drouy2(i,ik) &
                -(rum*rum+fff*dff)*dexp(-rum*rum*rr)*fff*rmm
           drouz2(i,ik)=drouz2(i,ik) &
                -(rum*rum+fff*dff)*dexp(-rum*rum*rr)*fff*rnn

!c               droux2(ik,i)=droux2(ik,i)
!c     &        +(rum**2.0d0+fff*dff)*dexp(-rum**2.0d0*rr)*fff*rll
!c               drouy2(ik,i)=drouy2(ik,i)
!c     &        +(rum**2.0d0+fff*dff)*dexp(-rum**2.0d0*rr)*fff*rmm
!c               drouz2(ik,i)=drouz2(ik,i)
!c     &        +(rum**2.0d0+fff*dff)*dexp(-rum**2.0d0*rr)*fff*rnn
        endif

!c               print *, i,rou(i)
!c            print 888, i,ik,rll,rmm,rnn,opps,oppp
!888     format(1x,i2,i2,d16.8,d16.8,d16.8,d16.8,i3,i3,i3)

        HMM(1,1)=VSS
        HMM(1,2)=RLL*VSP
        HMM(1,3)=RMM*VSP
        HMM(1,4)=RNN*VSP
        HMM(2,1)=-RLL*VSP
        HMM(3,1)=-RMM*VSP
        HMM(4,1)=-RNN*VSP
        HMM(2,2)=RLL**2*VPPS+(1.0D0-RLL**2)*VPPP
        HMM(3,3)=RMM**2*VPPS+(1.0D0-RMM**2)*VPPP
        HMM(4,4)=RNN**2*VPPS+(1.0D0-RNN**2)*VPPP
        HMM(2,3)=RLL*RMM*(VPPS-VPPP)
        HMM(3,2)=hMM(2,3)
        HMM(3,4)=RMM*RNN*(VPPS-VPPP)
        HMM(4,3)=hMM(3,4)
        HMM(2,4)=RLL*RNN*(VPPS-VPPP)
        HMM(4,2)=hMM(2,4)
        
        if(ks.eq.1) then
           do k=1,4
              do l=1,4
                 write(60,'(d16.8,5i3)') hmm(k,l),i,j,ik,k,l
              enddo
           enddo
        endif
        sMM(1,1)=oSS
        sMM(1,2)=RLL*oSP
        sMM(1,3)=RMM*oSP
        sMM(1,4)=RNN*oSP
        sMM(2,1)=-RLL*oSP
        sMM(3,1)=-RMM*oSP
        sMM(4,1)=-RNN*oSP
        sMM(2,2)=RLL**2*oPPS+(1.0D0-RLL**2)*oPPP
        sMM(3,3)=RMM**2*oPPS+(1.0D0-RMM**2)*oPPP
        sMM(4,4)=RNN**2*oPPS+(1.0D0-RNN**2)*oPPP
        sMM(2,3)=RLL*RMM*(oPPS-oPPP)
        sMM(3,2)=sMM(2,3)
        sMM(3,4)=RMM*RNN*(oPPS-oPPP)
        sMM(4,3)=sMM(3,4)
        sMM(2,4)=RLL*RNN*(oPPS-oPPP)
        sMM(4,2)=sMM(2,4)
        if(ks.eq.1) then
           do k=1,4
              do l=1,4
                 write(60,'(d16.8,5i3)') smm(k,l),i,j,ik,k,l
              enddo
           enddo
        endif
!C                                         
!C     DERIVATIVES OF TWO-CENTER PARAMETERS
!C                                         

        if (ik.ne.i) then
!c------Hamiltonian----------------------------------------
           DS1=bsss+2.0d0*esss*rr  
           DS2=bsps+2.0d0*esps*rr 
           DS3=bpps+2.0d0*epps*rr 
           DS4=bppp+2.0d0*eppp*rr 

           DdSS=(ds1*dexp(-dsss**2*rr)-vss*dff)*fff-dsss*dsss*vss      
           DdSP=(ds2*dexp(-dsps**2*rr)-vsp*dff)*fff-dsps*dsps*vsp       
           DdPPS=(ds3*dexp(-dpps**2*rr)-vpps*dff)*fff-dpps*dpps*vpps    
           DdPPP=(ds4*dexp(-dppp**2*rr)-vppp*dff)*fff-dppp*dppp*vppp            

           HMX(1,1)=-RLL*DdSS 
           HMY(1,1)=-RMM*DdSS 
           HMZ(1,1)=-RNN*DdSS 
           V1=-VSP/RR+DdSP            
           HMX(1,2)=-VSP/RR-RLL**2*V1
           HMY(1,2)=-RLL*RMM*V1      
           HMZ(1,2)=-RLL*RNN*V1      
           HMX(1,3)=-RLL*RMM*V1      
           HMY(1,3)=-VSP/RR-RMM**2*V1
           HMZ(1,3)=-RMM*RNN*V1      
           HMX(1,4)=-RLL*RNN*V1      
           HMY(1,4)=-RMM*RNN*V1      
           HMZ(1,4)=-VSP/RR-RNN**2*V1
           HMX(2,1)=-HMX(1,2)        
           HMY(2,1)=-HMY(1,2)        
           HMZ(2,1)=-HMZ(1,2)        
           HMX(3,1)=-HMX(1,3)        
           HMY(3,1)=-HMY(1,3)        
           HMZ(3,1)=-HMZ(1,3)        
           HMX(4,1)=-HMX(1,4)        
           HMY(4,1)=-HMY(1,4)        
           HMZ(4,1)=-HMZ(1,4)        
           V2=VPPS-VPPP              
           HMX(2,2)=-2.0D0*RLL*(1.0D0-RLL**2)/RR*V2-RLL**3*ddPPS &
                -RLL*(1.0D0-RLL**2)*DdPPP   
           HMY(2,2)=2.0D0*RLL**2*RMM/RR*V2-RLL**2*RMM*DdPPS &
                -RMM*(1.0D0-RLL**2)*DdPPP     
           HMZ(2,2)=2.0D0*RLL**2*RNN/RR*V2-RLL**2*RNN*DdPPS &
                -RNN*(1.0D0-RLL**2)*DdPPP        
           HMX(3,3)=2.0D0*RLL*RMM**2/RR*V2-RLL*RMM**2*DdPPS &
                -RLL*(1.0D0-RMM**2)*DdPPP       
           HMY(3,3)=-2.0D0*RMM*(1.0D0-RMM**2)/RR*V2-RMM**3*DdPPS &
                -RMM*(1.0D0-RMM**2)*DdPPP              
           HMZ(3,3)=2.0D0*RMM**2*RNN/RR*V2-RNN*RMM**2*DdPPS &
                -RNN*(1.0D0-RMM**2)*DdPPP   
           HMX(4,4)=2.0D0*RLL*RNN**2/RR*V2-RLL*RNN**2*DdPPS &
                -RLL*(1.0D0-RNN**2)*DdPPP      
           HMY(4,4)=2.0D0*RMM*RNN**2/RR*V2-RMM*RNN**2*DdPPS &
                -RMM*(1.0D0-RNN**2)*DdPPP       
           HMZ(4,4)=-2.0D0*RNN*(1.0D0-RNN**2)/RR*V2-RNN**3*DdPPS &
                -RNN*(1.0D0-RNN**2)*DdPPP        
           V3=DdPPS-DdPPP                                        
           HMX(2,3)=-RMM*(1.0D0-2.0D0*RLL**2)/RR*V2-RLL**2*RMM*V3 
           HMY(2,3)=-RLL*(1.0D0-2.0D0*RMM**2)/RR*V2-RLL*RMM**2*V3 
           HMZ(2,3)=2.0D0*RLL*RMM*RNN/RR*V2-RLL*RMM*RNN*V3        
           HMX(3,2)=HMX(2,3)                                      
           HMY(3,2)=HMY(2,3)                                      
           HMZ(3,2)=HMZ(2,3)                                      
           HMX(3,4)=2.0D0*RLL*RMM*RNN/RR*V2-RLL*RMM*RNN*V3        
           HMY(3,4)=-RNN*(1.0D0-2.0D0*RMM**2)/RR*V2-RMM**2*RNN*V3 
           HMZ(3,4)=-RMM*(1.0D0-2.0D0*RNN**2)/RR*V2-RMM*RNN**2*V3 
           HMX(4,3)=HMX(3,4)                                      
           HMY(4,3)=HMY(3,4)                                      
           HMZ(4,3)=HMZ(3,4)                                      
           HMX(2,4)=-RNN*(1.0D0-2.0D0*RLL**2)/RR*V2-RNN*RLL**2*V3 
           HMY(2,4)=2.0D0*RLL*RMM*RNN/RR*V2-RLL*RMM*RNN*V3        
           HMZ(2,4)=-RLL*(1.0D0-2.0D0*RNN**2)/RR*V2-RLL*RNN**2*V3 
           HMX(4,2)=HMX(2,4)                                      
           HMY(4,2)=HMY(2,4)                                      
           HMZ(4,2)=HMZ(2,4)
!c-----Overlap-----------------------------------------------                
           DS1=psss+2.0d0*qsss*rr+3.0d0*rsss*r2 
           DS2=psps+2.0d0*qsps*rr+3.0d0*rsps*r2
           DS3=ppps+2.0d0*qpps*rr+3.0d0*rpps*r2
           DS4=pppp+2.0d0*qppp*rr+3.0d0*rppp*r2
           DdSS=(ds1*dexp(-ssss*ssss*rr)-oss*dff)*fff-ssss*ssss*oss      
            DdSP=(ds2*dexp(-ssps*ssps*rr)-osp*dff)*fff-ssps*ssps*osp       
            DdPPS=(ds3*dexp(-spps*spps*rr)-opps*dff)*fff-spps*spps*opps    
            DdPPP=(ds4*dexp(-sppp*sppp*rr)-oppp*dff)*fff-sppp*sppp*oppp  
!c            if(i.eq.1) then
!c               print *, ddss,ddsp,ddpps,ddppp,ik
!c            endif
!C      sMX,sMY,sMZ

            sMX(1,1)=-RLL*DdSS 
            sMY(1,1)=-RMM*DdSS 
            sMZ(1,1)=-RNN*DdSS 
            V1=-oSP/RR+DdSP            
            sMX(1,2)=-oSP/RR-RLL**2*V1
            sMY(1,2)=-RLL*RMM*V1      
            sMZ(1,2)=-RLL*RNN*V1      
            sMX(1,3)=-RLL*RMM*V1      
            sMY(1,3)=-oSP/RR-RMM**2*V1
            sMZ(1,3)=-RMM*RNN*V1      
            sMX(1,4)=-RLL*RNN*V1      
            sMY(1,4)=-RMM*RNN*V1      
            sMZ(1,4)=-oSP/RR-RNN**2*V1
            sMX(2,1)=-sMX(1,2)        
            sMY(2,1)=-sMY(1,2)        
            sMZ(2,1)=-sMZ(1,2)        
            sMX(3,1)=-sMX(1,3)        
            sMY(3,1)=-sMY(1,3)        
            sMZ(3,1)=-sMZ(1,3)        
            sMX(4,1)=-sMX(1,4)        
            sMY(4,1)=-sMY(1,4)        
            sMZ(4,1)=-sMZ(1,4)        
            V2=oPPS-oPPP 
            sMX(2,2)=-2.0D0*RLL*(1.0D0-RLL**2)/RR*V2-RLL**3*DdPPS &
                 -RLL*(1.0D0-RLL**2)*DdPPP  
            sMY(2,2)=2.0D0*RLL**2*RMM/RR*V2-RLL**2*RMM*DdPPS &
                 -RMM*(1.0D0-RLL**2)*DdPPP 
            sMZ(2,2)=2.0D0*RLL**2*RNN/RR*V2-RLL**2*RNN*DdPPS &
                 -RNN*(1.0D0-RLL**2)*DdPPP
            sMX(3,3)=2.0D0*RLL*RMM**2/RR*V2-RLL*RMM**2*DdPPS &
                 -RLL*(1.0D0-RMM**2)*DdPPP 
            sMY(3,3)=-2.0D0*RMM*(1.0D0-RMM**2)/RR*V2-RMM**3*DdPPS &
                 -RMM*(1.0D0-RMM**2)*DdPPP
            sMZ(3,3)=2.0D0*RMM**2*RNN/RR*V2-RNN*RMM**2*DdPPS &
                 -RNN*(1.0D0-RMM**2)*DdPPP 
            sMX(4,4)=2.0D0*RLL*RNN**2/RR*V2-RLL*RNN**2*DdPPS &
                 -RLL*(1.0D0-RNN**2)*DdPPP
            sMY(4,4)=2.0D0*RMM*RNN**2/RR*V2-RMM*RNN**2*DdPPS &
                 -RMM*(1.0D0-RNN**2)*DdPPP  
            sMZ(4,4)=-2.0D0*RNN*(1.0D0-RNN**2)/RR*V2-RNN**3*DdPPS &
                 -RNN*(1.0D0-RNN**2)*DdPPP  
            V3=DdPPS-DdPPP                                        
            sMX(2,3)=-RMM*(1.0D0-2.0D0*RLL**2)/RR*V2-RLL**2*RMM*V3 
            sMY(2,3)=-RLL*(1.0D0-2.0D0*RMM**2)/RR*V2-RLL*RMM**2*V3 
            sMZ(2,3)=2.0D0*RLL*RMM*RNN/RR*V2-RLL*RMM*RNN*V3        
            sMX(3,2)=sMX(2,3)                                      
            sMY(3,2)=sMY(2,3)                                      
            sMZ(3,2)=sMZ(2,3)                                      
            sMX(3,4)=2.0D0*RLL*RMM*RNN/RR*V2-RLL*RMM*RNN*V3        
            sMY(3,4)=-RNN*(1.0D0-2.0D0*RMM**2)/RR*V2-RMM**2*RNN*V3 
            sMZ(3,4)=-RMM*(1.0D0-2.0D0*RNN**2)/RR*V2-RMM*RNN**2*V3 
            sMX(4,3)=sMX(3,4)                                      
            sMY(4,3)=sMY(3,4)                                      
            sMZ(4,3)=sMZ(3,4)                                      
            sMX(2,4)=-RNN*(1.0D0-2.0D0*RLL**2)/RR*V2-RNN*RLL**2*V3 
            sMY(2,4)=2.0D0*RLL*RMM*RNN/RR*V2-RLL*RMM*RNN*V3        
            sMZ(2,4)=-RLL*(1.0D0-2.0D0*RNN**2)/RR*V2-RLL*RNN**2*V3 
            sMX(4,2)=sMX(2,4)                                      
            sMY(4,2)=sMY(2,4)                                      
            sMZ(4,2)=sMZ(2,4)
!c---------------------------------------------------------------------
         endif
!c            if (i.eq.1) then
!c            print 99, hmx(1,1),hmx(1,2),hmx(1,3),hmx(1,4)
!c            print 99, hmx(2,1),hmx(2,2),hmx(2,3),hmx(3,4)
!c            print 99, hmx(3,1),hmx(3,2),hmx(3,3),hmx(3,4)
!c            print 99, hmx(4,1),hmx(4,4),hmx(3,4),hmx(4,4)
!c            print *, "  "
!c            endif
!99       format (1x,d16.8,d16.8,d16.8,d16.8)

         do k=1,4
            do l=1,4
               ar((i-1)*4+k,(ik-1)*4+l)=ar((i-1)*4+k,(ik-1)*4+l)+dreal(hmm(k,l)*ce)
               ai((i-1)*4+k,(ik-1)*4+l)=ai((i-1)*4+k,(ik-1)*4+l)+dimag(hmm(k,l)*ce)
               sr((i-1)*4+k,(ik-1)*4+l)=sr((i-1)*4+k,(ik-1)*4+l)+dreal(smm(k,l)*ce)
               si((i-1)*4+k,(ik-1)*4+l)=si((i-1)*4+k,(ik-1)*4+l)+dimag(smm(k,l)*ce)
               if (ik.ne.i) then 
                  hdx(l,k,j,i)=hmx(k,l)
                  hdy(l,k,j,i)=hmy(k,l)
                  hdz(l,k,j,i)=hmz(k,l)
!c               hhh(l,k,j,i)=hmm(k,l)
!c               sss(l,k,j,i)=smm(k,l)
!c               if (i.eq.1) then
!c               print *, hdy(l,k,j,i),hdx(l,k,j,i),ik
!c               endif 
               
                  sdx(l,k,j,i)=smx(k,l) 
                  sdy(l,k,j,i)=smy(k,l)
                  sdz(l,k,j,i)=smz(k,l)  
!c               print *, sdx(l,k,j,i),l,k,j,i,ik
               endif
            enddo
         enddo

      enddo ! do j=1,ni
   enddo ! do i=1,na

!c      print *, sddx,sddy,sddz
   do i=1,na
      es(i)=as+bs*rou(i)**(2.0d0/3.0d0) &
           +gs*rou(i)**(4.0d0/3.0d0)+rcs*rou(i)**2
      ep(i)=aq+bp*rou(i)**(2.0d0/3.0d0) &
           +gp*rou(i)**(4.0d0/3.0d0)+rcp*rou(i)**2
!c         if(ks.eq.1) then
!c            print *, es(i),ep(i),i,rou(i)
!c         endif
      do j=1,na
!c            if(i.ne.j) then
         desx(i,j)=(2.0d0/3.0d0*bs*rou(i)**(-1.0d0/3.0d0) &
              +4.0d0/3.0d0*gs*rou(i)**(1.0d0/3.0d0) &
              +2.0d0*rcs*rou(i))*droux2(i,j)
         desy(i,j)=(2.0d0/3.0d0*bs*rou(i)**(-1.0d0/3.0d0) &
              +4.0d0/3.0d0*gs*rou(i)**(1.0d0/3.0d0) &
              +2.0d0*rcs*rou(i))*drouy2(i,j)
         desz(i,j)=(2.0d0/3.0d0*bs*rou(i)**(-1.0d0/3.0d0) &
              +4.0d0/3.0d0*gs*rou(i)**(1.0d0/3.0d0) &
              +2.0d0*rcs*rou(i))*drouz2(i,j)
         
         depx(i,j)=(2.0d0/3.0d0*bp*rou(i)**(-1.0d0/3.0d0) &
              +4.0d0/3.0d0*gp*rou(i)**(1.0d0/3.0d0) &
              +2.0d0*rcp*rou(i))*droux2(i,j)
         depy(i,j)=(2.0d0/3.0d0*bp*rou(i)**(-1.0d0/3.0d0) &
              +4.0d0/3.0d0*gp*rou(i)**(1.0d0/3.0d0) &
              +2.0d0*rcp*rou(i))*drouy2(i,j)
         depz(i,j)=(2.0d0/3.0d0*bp*rou(i)**(-1.0d0/3.0d0) &
              +4.0d0/3.0d0*gp*rou(i)**(1.0d0/3.0d0) &
              +2.0d0*rcp*rou(i))*drouz2(i,j)
!c            print *, depx(i,j),i,j,rou(j),droux(i,j)
!c            endif

!c             if(i.eq.j) then
!c            desx(i,j)=(2.0d0/3.0d0*bs*rou(i)**(-1.0d0/3.0d0)
!c     &           +4.0d0/3.0d0*gs*rou(i)**(1.0d0/3.0d0)
!c     &           +2.0d0*rcs*rou(i))*droux(j)
!c            desy(i,j)=(2.0d0/3.0d0*bs*rou(i)**(-1.0d0/3.0d0)
!c     &           +4.0d0/3.0d0*gs*rou(i)**(1.0d0/3.0d0)
!c     &           +2.0d0*rcs*rou(i))*drouy(j)
!c            desz(i,j)=(2.0d0/3.0d0*bs*rou(i)**(-1.0d0/3.0d0)
!c     &           +4.0d0/3.0d0*gs*rou(i)**(1.0d0/3.0d0)
!c     &           +2.0d0*rcs*rou(i))*drouz(j)
!c            depx(i,j)=(2.0d0/3.0d0*bp*rou(i)**(-1.0d0/3.0d0)
!c     &           +4.0d0/3.0d0*gp*rou(i)**(1.0d0/3.0d0)
!c     &           +2.0d0*rcp*rou(i))*droux(j)
!c            depy(i,j)=(2.0d0/3.0d0*bp*rou(i)**(-1.0d0/3.0d0)
!c     &           +4.0d0/3.0d0*gp*rou(i)**(1.0d0/3.0d0)
!c     &           +2.0d0*rcp*rou(i))*drouy(j)
!c            depz(i,j)=(2.0d0/3.0d0*bp*rou(i)**(-1.0d0/3.0d0)
!c     &           +4.0d0/3.0d0*gp*rou(i)**(1.0d0/3.0d0)
!c     &           +2.0d0*rcp*rou(i))*drouz(j)
!cc            print *, depx(i,j),i,j,rou(j),droux(i,j)
!c            endif

      enddo ! do j=1,na
!c         print *, es(i),ep(i),i,ks
!c         es(i)=es(i)-7.42226
!c         ep(i)=ep(i)-0.40474
   enddo ! do i=1,na

!c      print *, rou(1)
   do i=1,na
      ar((i-1)*4+1,(i-1)*4+1)=ar((i-1)*4+1,(i-1)*4+1)+es(i)
      ar((i-1)*4+2,(i-1)*4+2)=ar((i-1)*4+2,(i-1)*4+2)+ep(i)
      ar((i-1)*4+3,(i-1)*4+3)=ar((i-1)*4+3,(i-1)*4+3)+ep(i)
      ar((i-1)*4+4,(i-1)*4+4)=ar((i-1)*4+4,(i-1)*4+4)+ep(i)
      
!c         sr((i-1)*4+1,(i-1)*4+1)=sr((i-1)*4+1,(i-1)*4+1)+es(i)
!c         sr((i-1)*4+2,(i-1)*4+2)=sr((i-1)*4+2,(i-1)*4+2)+ep(i)
!c         sr((i-1)*4+3,(i-1)*4+3)=sr((i-1)*4+3,(i-1)*4+3)+ep(i)
!c         sr((i-1)*4+4,(i-1)*4+4)=sr((i-1)*4+4,(i-1)*4+4)+ep(i)

      sr((i-1)*4+1,(i-1)*4+1)=sr((i-1)*4+1,(i-1)*4+1)+1.0d0
      sr((i-1)*4+2,(i-1)*4+2)=sr((i-1)*4+2,(i-1)*4+2)+1.0d0
      sr((i-1)*4+3,(i-1)*4+3)=sr((i-1)*4+3,(i-1)*4+3)+1.0d0
      sr((i-1)*4+4,(i-1)*4+4)=sr((i-1)*4+4,(i-1)*4+4)+1.0d0
   enddo
      
!c      print *, desx(4,4),desy(2,2),desz(2,1)
!c      print *, as,aq

 end subroutine const_hs
