!C  ***************************************************************** 
!C                                                                    
!C                          TIGHT-BINDING
!C                                                                   
!C  ****************************************************************  
!subroutine papatb4(na,ns,man,nm,x,y,z,ndif,dos,nds,weight &
!     ,xs,ys,zs,ak,a1,a2,a3,fx,fy,fz,rc,rr2,et &
!     ,ar,ai,hdx,hdy,hdz,fhx,fhy,fhz,rwork,sr,si,rou,es,ep &
!     ,ar,ai,fhx,fhy,fhz,rwork,sr,si,rou,es,ep &
!     ,sdx,sdy,sdz,desx,desy,desz,w,caa,cbb,work &
!     ,droux2,drouy2,drouz2,evalue)
subroutine papatb4
  use variables
  implicit double precision(a,b,d-h,o-z),integer(i-n),complex*16(c)
!  dimension x(na),y(na),z(na),xs(ns),ys(ns),zs(ns),ak(ns)
!  dimension dx(man,na),dy(man,na),dz(man,na),ip(man,na),nn(na)
!  dimension fx(na),fy(na),fz(na)
!  dimension a1(3),a2(3),a3(3)
!  dimension ar(nm,nm),ai(nm,nm)
!  dimension hdx(4,4,man,na),hdy(4,4,man,na),hdz(4,4,man,na)
!  dimension fhx(na),fhy(na),fhz(na)
!  dimension rwork((3*nm-1)*nm),dos1(nds),dos2(nds),dos3(nds)
!  dimension sr(nm,nm),si(nm,nm),rou(na),es(na),ep(na)
!  dimension sdx(4,4,man,na),sdy(4,4,man,na),sdz(4,4,man,na)
!  dimension desx(na,na),desy(na,na),desz(na,na),w(nm)
!  dimension depx(na,na),depy(na,na),depz(na,na),ew(nm),dos(nds)
!  dimension caa(nm,nm),cbb(nm,nm),evalue(nm,ns),weight(nm,ns)
!  dimension droux2(na,na),drouy2(na,na),drouz2(na,na)

!  complex*16 work((3*nm-1)*nm)

!c     .. Scalar Arguments ..
  CHARACTER          JOBZ, UPLO
  INTEGER            INFO, ITYPE, LDA, LDB, LWORK, N
  nm=mm
!c     ..
!c     .. Array Arguments ..
!c      DOUBLE PRECISION   RWORK( 3*nm-2 ), W( nm )
!c      COMPLEX*16          WORK(2*nm-1)
!c------------------------------------------------------------------
!c      print *, "asd"
!c-----ѥ᡼
!c      rr2=rc**2d0
!c      print *, nm
!c      print *, epps

!c      eb=0.0d0
!c      do i=1,nm
!c         do j=1,nm
!c            print *, "ok"
!c            caa(i,j)=0.0d0
!c            cbb(i,j)=0.0d0
!c         enddo
!c      enddo
!  a1x=a1(1)
!  a1y=a1(2)
!  a1z=a1(3)
!  a2x=a2(1)
!  a2y=a2(2)
!  a2z=a2(3)
!  a3x=a3(1)
!  a3y=a3(2)
!  a3z=a3(3)
!c      do i=1,na
!c         print *, x(i),y(i),z(i)
!c      enddo
!c      print *, rc

!c-----γϿ----------------------------------------------------------
123 continue
!  call registration2(na,man,rc,rr2,a1x,a1y,a1z,a2x,a2y,a2z, &
!       a3x,a3y,a3z,x,y,z,dx,dy,dz,ip,nn)
  call registration2
  
!c      if(nn(1).lt.10) then
!c         rc=rc+0.1d0/0.529177d0
!c         rr2=rc*rc
!c         print *, " "
!c         print '(1x,"NOT_ENOUGH_NEIGHBOURS",1x,"N=",i3)',nn(1)
!c         print '(1x,"EXPANDING_CUT_OFF_TO",d16.8)',rc*0.529177d0
!c         go to 123
!c      endif
!c      if(nn(1).gt.20) then
!c         rc=rc-0.1d0/0.529177d0
!c         rr2=rc*rc
!c         print *, " "
!c         print '(1x,"TOO_MUCH_NEIGHBOURS",1x,"N=",i3)',nn(1)
!c         print '(1x,"REDUCING_CUT_OFF_TO",d16.8)',rc*0.529177d0
!c         go to 123
!c      endif
!c-------------------------------------------------------------------

!c-----ͥ륮ϤΥꥻå--------------------------------------------
  eb=0.0d0
  do i=1,na
     fhx(i)=0.0d0
     fhy(i)=0.0d0
     fhz(i)=0.0d0
  enddo
!c-------------------------------------------------------------------
!  do k=1,nds
!     dos(k)=0.0d0
!     dos1(k)=0.0d0
!     dos2(k)=0.0d0
!     dos3(k)=0.0d0
!  enddo

  do ks=1,ns
     print *,"k = ",ks

!c-----ϤߤȤˤ׻-----------------------------------------------
!     call const_hs(na,nm,man,ns,ks,x,y,z,dx,dy,dz,ar,ai,sr,si, &
!          ip,nn,xs,ys,zs,rou,droux2,drouy2,drouz2, &
!          es,ep,desx,desy,desz,depx,depy,depz, &
!          hdx,hdy,hdz,sdx,sdy,sdz)
!          sdx,sdy,sdz)
     call const_hs(ks)
!c------------------------------------------------------------------
      
     do i=1,nm
        do j=1,nm
           cbb(i,j)=cmplx(sr(i,j),si(i,j))
           caa(i,j)=cmplx(ar(i,j),ai(i,j))
           if(ks.eq.1) write(89,*) caa(i,j)
        enddo
     enddo
     
!c-----ͭͤη׻
     noc=2*na
     itype=1
     uplo='u'
     jobz='V'
     lwork=(nm+1)*nm

     call ZHEGV( ITYPE, JOBZ, UPLO, Nm, caA, nm, cbB, nm, &
          W, WORK,LWORK, RWORK, INFO )
!c        print *, "ok2"
     if(info.ne.0) print *, "ERROR in papatb4",Nm,info

!c      if (ks.eq.1) eganma=w(noc/2)
     do i=1,nm
        ew(i)=w(i)*13.6d0
     enddo

!      if(ndif.eq.0) then
!         if(ire.eq.krm) then
!            call dost(na,ns,nm,ks,ew,ak,dos,dos1,dos2,dos3,nds,caa)
!         endif
!      endif

     do i=1,nm
        eivtot=0.0d0
        do j=1,nm
           eivtot=eivtot+abs(caa(j,i))**2
        enddo
!c         eivtot=sqrt(eivtot)
!c         write(23,*), ks,(w(i)-eganma)*13.6d0
        eivc=abs(caa(1,i))**2/eivtot+abs(caa(2,i))**2/eivtot+ &
             abs(caa(3,i))**2/eivtot+abs(caa(4,i))**2/eivtot
!c         eivc=abs(caa(177,i))**2/eivtot+abs(caa(178,i))**2/eivtot+
!c     &        abs(caa(179,i))**2/eivtot+abs(caa(180,i))**2/eivtot
        evalue(i,ks)=w(i)*13.6d0
        weight(i,ks)=eivc
!c         if(eivc.lt.0.032d0) evalue(i,ks)=-15.0d0
!c         do j=1,nm
!c            print *,i,j,evr(j,i),evi(j,i)
!c         enddo
     enddo

!c      print *, eb
!c-----Ϥȥͥ륮η׻

!     call calc_ef(na,nm,man,ns,ks,noc,dx,dy,dz,caa,eb,xs,ys,zs, &
!          ak,nn,ip,w,hdx,hdy,hdz,sdx,sdy,sdz,fhx,fhy,fhz,desx,desy, &
!          ak,nn,ip,w,sdx,sdy,sdz,fhx,fhy,fhz,desx,desy, &
!          desz,depx,depy,depz)
     call calc_ef(ks)
  end do

      
!     unit: Newton
  do i=1,na
!c         fx(i)=-fhx(i)*13.6d0*1.60219d-9/0.529177d0
!c         fy(i)=-fhy(i)*13.6d0*1.60219d-9/0.529177d0
!c         fz(i)=-fhz(i)*13.6d0*1.60219d-9/0.529177d0
     fx(i)=fhx(i)*13.6d0*1.60219d-9/0.529177d0
     fy(i)=fhy(i)*13.6d0*1.60219d-9/0.529177d0
     fz(i)=fhz(i)*13.6d0*1.60219d-9/0.529177d0
!c         print 909, i,fx(i),fy(i),fz(i)
  enddo
909 format(1x,"FORCE=",i3,3d16.8)
  et=eb

end subroutine papatb4
