c*************************************************************************
c                                 RASMOL
c*************************************************************************
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      parameter(na=4,man=1000)
      dimension x(na),y(na),z(na),xr(man),yr(man),zr(man)
      
      open(60,file='r-dat.xyz')
      nread=11
      do j=1,12
         open(40,file='cood_relaxed.dat')
         open(50,file='trans-vector.dat')
         
         read(50,332) a1x,a1y,a1z
         read(50,332) a2x,a2y,a2z
         read(50,332) a3x,a3y,a3z
         read(50,*)
         do i=1,na
            read(40,332) x(i),y(i),z(i)
            print *, x(i),y(i),z(i),i
         enddo
         read(40,*)
 332     format(1x,d26.16,d26.16,d26.16)      
         nn=0
         do 1 k=1,na
            do 10 i1=-5,5
               do 20 i2=-5,5
                  do 30 i3=-5,5
                     xx=x(k)+i1*a1x+i2*a2x+i3*a3x
                     if(abs(xx).gt.2*a1x) go to 20
                     yy=y(k)+i1*a1y+i2*a2y+i3*a3ys
                     if(abs(yy).gt.2*a1x) go to 20
                     zz=z(k)+i1*a1z+i2*a2z+i3*a3z
                     if(abs(zz).gt.1*a1x) go to 30
                     nn=nn+1
                     xr(nn)=xx
                     yr(nn)=yy
                     zr(nn)=zz
c                     print *, xx,yy,zz,j,k
 30               continue
 20            continue
 10         continue
 1       continue
         if(j.eq.nread) then
            write(60,*) nn
            write(60,*) "0"
            do n=1,nn
               write(60,111) xr(n),yr(n),zr(n)
            enddo
         endif
 111     format("c",d26.16,d26.16,d26.16)
      enddo


         close(40)
         close(50)

         end
